<template>
    <div>
        <el-card>
            <el-form :inline="true" :model="filterQuery" size="mini">
                <el-row style="width: 100%">
                    <el-form-item class="query-form-item">
                        <el-select v-model="filterQuery.invStorageCode" placeholder="请选择当前仓库" clearable="true"
                                   @change="invChange"
                                   size="mini">
                            <el-option
                                v-for="item in storageList"
                                :key="item.name"
                                :label="item.name"
                                :value="item.code">
                                <span style="float: left">{{ item.name }}</span>
                            </el-option>
                        </el-select>
                    </el-form-item>
                    <el-form-item class="query-form-item">
                        <el-select v-model="filterQuery.invWarehouseCode" placeholder="请选择当前分库" clearable="true"
                                   :disabled="invWarehouseDisabled"
                                   size="mini">
                            <el-option
                                v-for="item in subInvList"
                                :key="item.name"
                                :label="item.name"
                                :value="item.code">
                                <span style="float: left">{{ item.name }}</span>
                            </el-option>
                        </el-select>
                    </el-form-item>
                    <el-form-item class="query-form-item">
                        <el-select v-model="filterQuery.invSpaceCode" placeholder="请选择货位" clearable="true"
                                   :disabled="invWarehouseDisabled"
                                   size="mini">
                            <el-option
                                v-for="item in spaceCodeList"
                                :key="item.name"
                                :label="item.name"
                                :value="item.code">
                                <span style="float: left">{{ item.name }}</span>
                            </el-option>
                        </el-select>
                    </el-form-item>
                    <el-form-item>
                        <el-button-group>
                            <el-button
                                type="primary"
                                icon="el-icon-refresh"
                                @click="onReset"
                            ></el-button>
                            <el-button type="primary" icon="search" @click="onSubmit">查询</el-button>
                            <el-button type="primary" icon="search" @click="addCountOrder">新增盘点单</el-button>
                        </el-button-group>
                    </el-form-item>
                </el-row>
            </el-form>
            <el-table v-loading="loading" :data="list" style="width: 100%">
                <el-table-column label="序号" type="index"></el-table-column>
                <el-table-column label="盘点单号" prop="orderId" width="180"></el-table-column>
                <el-table-column label="仓库" prop="invStorageName" width="180"></el-table-column>
                <el-table-column label="分库" prop="invSubStorageName" width="180"
                                 show-overflow-tooltip></el-table-column>
                <el-table-column label="货位" prop="invSpaceName" width="120"></el-table-column>
                <el-table-column label="盘点人" prop="createUser" width="120"></el-table-column>
                <el-table-column label="盘点时间" prop="createTime" width="150"></el-table-column>
                <el-table-column label="状态" prop="status" width="120">
                    <template slot-scope="scope">
                        <el-tag>
                            {{ statusMap[scope.row.status] }}
                        </el-tag>
                    </template>
                </el-table-column>
                <el-table-column label="操作" width="180" fixed="right">
                    <template slot-scope="scope">
                        <el-button
                            type="text"
                            size="small"
                            @click.native.stop="editOrder(scope.row)"
                        >编辑
                        </el-button
                        >
                        <el-button
                            type="text"
                            size="small"
                            @click.native.stop="submitAudit(scope.row)"
                        >提交审核
                        </el-button
                        >
                        <el-button
                            type="text"
                            size="small"
                            @click.native.stop="deleteDialog(scope.row.id)"
                        >删除
                        </el-button
                        >
                    </template>
                </el-table-column>
            </el-table>
        </el-card>

        <el-pagination
            :page-size="filterQuery.limit"
            @current-change="handleCurrentChange"
            layout="prev, pager, next"
            :total="total"
        ></el-pagination>

        <el-dialog
            title="新增盘点单"
            :visible.sync="addCountOrderVisible"
            width="70%"
            :close-on-click-modal="false"
            :close-on-press-escape="false"
            v-if="addCountOrderVisible"
        >
            <addCountOrder
                :closeDialog="closeAddDialog"
            ></addCountOrder>
        </el-dialog>


    </div>
</template>

<script>
import store from "../../store";
import {getCountOrderList, deleteCountOrder, submitAudit} from "@/api/inventory/invCountOrder";
import {filterUplLocInv} from "@/api/basic/invWarehouse";
import {filterSubByInv} from "@/api/basic/invSubWarehouse";
import {userInfo} from "@/api/auth/login";
import {isBlank} from "@/utils/strUtil";
import addCountOrder from "./addCountOrder";

export default {
    data() {
        return {
            filterQuery: {
                invWarehouseCode: null,
                invStorageCode: null,
                invSpaceCode: null,
                status: 0,
                page: 1,
                limit: 20,
                customerId: null
            },
            list: [],
            storageList: [],
            subInvList: [],
            codeDetailVisible: false,
            total: 0,
            loading: true,
            invWarehouseDisabled: true,
            spaceCodeList: [],
            statusMap: {
                0: "未提交",
                1: "未审核",
                2: "已审核"
            },
            addCountOrderVisible: false,

        };
    },
    methods: {
        onReset() {
            this.$router.push({
                path: "",
            });
            this.filterQuery = {
                customerId: null,
                invWarehouseCode: null,
                invStorageCode: null,
                status: 0,
                page: 1,
                limit: 20,
            };
            this.invChange();
            this.getList();
        },
        onSubmit() {
            this.loading = true;
            this.filterQuery.page = 1;
            this.getList();
        },
        handleCurrentChange(val) {
            this.filterQuery.page = val;
            this.getList();
        },
        getList() {
            this.loading = true;
            this.filterQuery.customerId = store.getters.customerId;
            getCountOrderList(this.filterQuery).then((res) => {
                this.loading = false;
                if (res.code === 20000) {
                    this.list = res.data.list || [];
                    this.total = res.data.total || 0;
                } else {
                    this.list = [];
                    this.total = 0;
                }
            }).catch((error) => {
                this.loading = false;
                this.list = [];
                this.total = 0;
            })
        },

        deleteOrders(data) {
            this.loading = true;
            let params = {
                id: data,
            }
            deleteCountOrder(params).then((res) => {
                if (res.code === 20000) {
                    this.$message.success("删除成功！");
                    this.getList();
                } else {
                    this.$message.error(res.data.message);
                }
            })
        },
        deleteDialog(rowId) {
            this.$confirm("此操作将永久删除该盘点单, 是否继续?", "提示", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning",
            })
                .then(() => {
                    this.deleteOrders(rowId);
                })
                .catch(() => {
                });
        },
        getStorage() {
            this.storageList = [];
            filterUplLocInv()
                .then((response) => {
                    this.storageList = response.data || [];
                })
                .catch(() => {
                });
        },
        invChange() {
            this.filterQuery.invWarehouseCode = "";
            this.subInvList = [];
            if (this.filterQuery.invStorageCode != null && this.filterQuery.invStorageCode != "") {
                this.invWarehouseDisabled = false;
                let query = {
                    pcode: this.filterQuery.invStorageCode
                };
                filterSubByInv(query)
                    .then((response) => {
                        this.subInvList = response.data || [];
                    })
                    .catch(() => {
                    });
            } else {
                this.invWarehouseDisabled = true;
            }
        },
        submitAudit(row) {
            let params = {id: row.id};
            submitAudit(params).then((res) => {
                if (res.code === 20000) {
                    this.$message.success("提交成功");
                    this.getList();
                } else {
                    this.$message.error(res.message);
                }
            })
        },
        addCountOrder() {
            this.addCountOrderVisible = true;
        },
        closeAddDialog() {
            this.addCountOrderVisible = false;
            this.getList();
        },
        editOrder() {

        },
    },
    components: {
        addCountOrder
    },
    created() {
        this.getStorage();
        let query = this.$route.query;
        this.filterQuery = Object.assign(this.filterQuery, query);
        this.filterQuery.limit = parseInt(this.filterQuery.limit);
        // 加载表格数据
        //获取用户默认仓库信息
        userInfo().then((res) => {
            if (res.code === 20000) {
                if (!isBlank(res.data.locInvCode)) {
                    this.filterQuery.invStorageCode = res.data.locInvCode;
                    this.invChange();
                    this.filterQuery.invWarehouseCode = res.data.locSubInvCode;
                }
                this.getList();
            }
        }).catch((error) => {
        });
    },
};
</script>

<style type="text/scss" lang="scss">
</style>
